<?php
declare(strict_types=1);

use Migrations\AbstractSeed;

/**
 * Initial seed.
 *
 * Apply:
 * oitc migrations seed -p MassenversandDeModule
 */
class InitialSeed extends AbstractSeed {
    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeds is available here:
     * https://book.cakephp.org/phinx/0/en/seeding.html
     *
     * @return void
     */
    public function run(): void {
        //Commands
        $table = $this->table('commands');

        $data = [
            [
                'name'         => 'host-notifiy-by-massenversand',
                'command_line' => '/opt/openitc/frontend/bin/cake massenversandDeModule.notifyByMassenversandDe -r $CONTACTPAGER$ -s openITCOCKPIT --id YOURACCOUNTID --pw YOURACCOUNTPWD --type host --hostuuid $HOSTNAME$ --hoststate $HOSTSTATE$',
                'command_type' => NOTIFICATION_COMMAND,
                'human_args'   => null,
                'uuid'         => \itnovum\openITCOCKPIT\Core\UUID::v4(),
                'description'  => 'Host notification by massenversand.de'
            ],
            [
                'name'         => 'service-notify-by-massenversand',
                'command_line' => '/opt/openitc/frontend/bin/cake massenversandDeModule.notifyByMassenversandDe -r $CONTACTPAGER$ -s openITCOCKPIT --id YOURACCOUNTID --pw YOURACCOUNTPWD --type service --serviceuuid $SERVICEDESC$ --servicestate $SERVICESTATE$',
                'command_type' => NOTIFICATION_COMMAND,
                'human_args'   => null,
                'uuid'         => \itnovum\openITCOCKPIT\Core\UUID::v4(),
                'description'  => 'Service notification by massenversand.de'
            ]
        ];

        //Check if records exists
        foreach ($data as $index => $record) {
            $QueryBuilder = $this->getAdapter()->getQueryBuilder();

            $stm = $QueryBuilder->select('*')
                ->from($table->getName())
                ->where([
                    'command_type' => NOTIFICATION_COMMAND,
                    'name'         => $record['name']
                ])
                ->execute();
            $result = $stm->fetchAll();

            if (empty($result)) {
                $table->insert($record)->save();
            }
        }
    }
}
